#include <FK/FK.h>
#include "TrackBall.h"
#include "OBB.h"
#include "FrameController.h"
#include "Field.h"

// }EẌړʂɉăJ𓮂FPSIȃA
void procMouseView(fk_Model &camera, bool lockSW)
{
	static POINT	po;
	static int		nowX, nowY, nowZ, prevX, prevY;
	static double	diffX, diffY;
	static bool		once = false;
	const double	spinRate = 0.001;
	const double	moveRate = 5.0;

	GetCursorPos(&po);
	if(once == false) {
		prevX = po.x;
		prevY = po.y;
		once = true;
	}
	nowZ = Fl::e_dy;
	Fl::e_dy = 0;

	nowX = po.x;
	nowY = po.y;
	diffX = nowX - prevX;
	diffY = nowY - prevY;
	camera.loAngle(diffX*spinRate, 0.0, 0.0);
	camera.loAngle(0.0, diffY*spinRate, 0.0);
	camera.glAngle(camera.getAngle().h, camera.getAngle().p, 0.0);
	camera.loTranslate(0.0, 0.0, nowZ*moveRate);
	if(lockSW == true){
		SetCursorPos(prevX, prevY);
	} else {
		prevX = nowX;
		prevY = nowY;
	}
}

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(800, 600, "COLLISION TEST");
	fk_Model		camera, lightModel;
	fk_Light		light;
	fk_Scene		scene;
	fk_Window		window(0, 0, 800, 600);

	fk_TrackBall	tb(&window, &camera);
	fk_Vector		spd, acc, view, norm, back, refV;
	fk_Matrix		rotMat;

	fk_Model		playerModel;
	fk_Block		playerBox(4.0, 4.0, 4.0);
	fkut_OBB		playerOBB;

	CField			fieldObj;

	fkut_FrameController	fc;

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);

	// ̂̐ݒ
	playerModel.setShape(&playerBox);
	playerModel.setMaterial(Cyan);
	playerModel.setSmoothMode(true);
	playerModel.glMoveTo(0.0, 15.0, 0.0);
	playerOBB.setBlockSize(4.0, 4.0, 4.0);
	playerOBB.setModel(&playerModel);

	// effBXvCXgɓo^
	fieldObj.entryScene(&scene);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	scene.entryModel(&playerModel);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	rotMat.makeRot(FK_PI/2.0, fk_Y);

	mainWindow.show();
	window.show();

	while(true) {
		static bool prevJump = false;

		fc.TimeRegular();

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		tb.update();
		//procMouseView(playerModel, true);

		if(fc.GetDrawFlag()) window.drawWindow();
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		// J XZ Ƃɐis
		view = camera.getVec();
		view.y = 0.0;
		view.normalize();

		// Wv̏x XZ ̊x悹
		if(window.getKeyStatus(' ', false) & !prevJump) {
			acc.x = spd.x;
			acc.z = spd.z;
			acc.y = 2.0;
		}
		prevJump = window.getKeyStatus(' ', false);

		// n㎞͓x^A󒆂ł͉x
		spd.init();
		if(window.getSpecialKeyStatus(FK_UP, false)) {
			if(abs(acc.y) > 0.0) acc += view*0.1;
			else spd += view*0.5;
		}
		if(window.getSpecialKeyStatus(FK_DOWN, false)) {
			if(abs(acc.y) > 0.0) acc -= view*0.1;
			else spd -= view*0.5;
		}
		if(window.getSpecialKeyStatus(FK_LEFT, false)) {
			if(abs(acc.y) > 0.0) acc += rotMat*view*0.1;
			else spd += rotMat*view*0.5;
		}
		if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
			if(abs(acc.y) > 0.0) acc -= rotMat*view*0.1;
			else spd -= rotMat*view*0.5;
		}
		if(spd.normalize()) spd *= 0.5;

		// d͉x
		acc.y -= 0.098;
		if(acc.x*acc.x + acc.z*acc.z > 0.5*0.5) {
			double tmpSpdLen = sqrt(acc.x*acc.x + acc.z*acc.z);
			acc.x *= 0.5/tmpSpdLen;
			acc.z *= 0.5/tmpSpdLen;
		} else {
			acc.x *= 0.9;
			acc.z *= 0.9;
		}

		// x𑬓xɏ悹
		spd += acc;

		// Փ˔Ăяo
		if(fieldObj.checkCollision(playerOBB, &spd)) acc.init();

		// x𑀍샂fɉĎۂɓ
		playerModel.glTranslate(spd);
		camera.glTranslate(spd.x, 0.0, spd.z);
		tb.setLookTo(fk_Vector(playerModel.getPosition().x, 0.0, playerModel.getPosition().z));
	}

	return 0;
}
